osgDB::ListSerializer< C, P > Class Template Reference

`#include <Serializer>`

Inheritance diagram for osgDB::ListSerializer< C, P >:

## Public Types

typedef P::value_type | ValueType
typedef P::const_iterator | ConstIterator
typedef const P &(C::* | Getter) () const
typedef void(C::* | Setter) (const P &)
Public Types inherited from osgDB::BaseSerializer

enum

Type {
RW_UNDEFINED = 0 , RW_USER , RW_OBJECT , RW_IMAGE ,
RW_LIST , RW_BOOL , RW_CHAR , RW_UCHAR ,
RW_SHORT , RW_USHORT , RW_INT , RW_UINT ,
RW_FLOAT , RW_DOUBLE , RW_VEC2F , RW_VEC2D ,
RW_VEC3F , RW_VEC3D , RW_VEC4F , RW_VEC4D ,
RW_QUAT , RW_PLANE , RW_MATRIXF , RW_MATRIXD ,
RW_MATRIX , RW_GLENUM , RW_STRING , RW_ENUM ,
RW_VEC2B , RW_VEC2UB , RW_VEC2S , RW_VEC2US ,
RW_VEC2I , RW_VEC2UI , RW_VEC3B , RW_VEC3UB ,
RW_VEC3S , RW_VEC3US , RW_VEC3I , RW_VEC3UI ,
RW_VEC4B , RW_VEC4UB , RW_VEC4S , RW_VEC4US ,
RW_VEC4I , RW_VEC4UI , RW_BOUNDINGBOXF , RW_BOUNDINGBOXD ,
RW_BOUNDINGSPHEREF , RW_BOUNDINGSPHERED , RW_VECTOR , RW_MAP
}

enum | Usage { READ_WRITE_PROPERTY = 1 , GET_PROPERTY = 2 , SET_PROPERTY = 4 , GET_SET_PROPERTY = GET_PROPERTY | SET_PROPERTY }

## Public Member Functions

| ListSerializer (const char *name, Getter gf, Setter sf)
virtual const std::string & | getName () const
virtual bool | read (InputStream &is, osg::Object &obj)
virtual bool | write (OutputStream &os, const osg::Object &obj)
Public Member Functions inherited from osgDB::BaseSerializer
| BaseSerializer (int usage)
virtual bool | set (osg::Object &, void *)
virtual bool | get (const osg::Object &, void *)
virtual IntLookup * | getIntLookup ()
void | setUsage (int usage)
int | getUsage () const
void | setUsage (bool hasGetter, bool hasSetter)
bool | supportsReadWrite () const
bool | supportsGetSet () const
bool | supportsGet () const
bool | supportsSet () const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
virtual void | setThreadSafeRefUnref (bool)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Public Attributes

std::string | _name
Getter | _getter
Setter | _setter

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const
Protected Attributes inherited from osgDB::BaseSerializer
int | _firstVersion
int | _lastVersion
int | _usage
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Member Typedef Documentation

## ConstIterator

template<typename C, typename P>

typedef P::const_iterator osgDB::ListSerializer< C, P >::ConstIterator

## Getter

template<typename C, typename P>

typedef const P &(C::* osgDB::ListSerializer< C, P >::Getter) () const

## Setter

template<typename C, typename P>

typedef void(C::* osgDB::ListSerializer< C, P >::Setter) (const P &)

## ValueType

template<typename C, typename P>

typedef P::value_type osgDB::ListSerializer< C, P >::ValueType

## Constructor & Destructor Documentation

## ListSerializer()

template<typename C, typename P>

osgDB::ListSerializer< C, P >::ListSerializer | ( | const char * | name,
|  | Getter | gf,
|  | Setter | sf )

inline

References _getter, _name, _setter, osgDB::BaseSerializer::BaseSerializer(), and osgDB::BaseSerializer::READ_WRITE_PROPERTY.

## Member Function Documentation

## getName()

template<typename C, typename P>

virtual const std::string & osgDB::ListSerializer< C, P >::getName | ( |  | ) | const

inline virtual

Implements osgDB::BaseSerializer.

References _name.

## read()

template<typename C, typename P>

virtual bool osgDB::ListSerializer< C, P >::read | ( | InputStream & | is,
|  | osg::Object & | obj )

inline virtual

Implements osgDB::BaseSerializer.

References _name, _setter, osgDB::InputStream::BEGIN_BRACKET, osgDB::InputStream::END_BRACKET, osgDB::InputStream::isBinary(), osgDB::InputStream::matchString(), and OBJECT_CAST.

## write()

template<typename C, typename P>

virtual bool osgDB::ListSerializer< C, P >::write | ( | OutputStream & | os,
|  | const osg::Object & | obj )

inline virtual

Implements osgDB::BaseSerializer.

References _getter, _name, osgDB::OutputStream::BEGIN_BRACKET, osgDB::OutputStream::END_BRACKET, osgDB::OutputStream::isBinary(), OBJECT_CAST, and osgDB::OutputStream::PROPERTY.

## Member Data Documentation

## _getter

template<typename C, typename P>

Getter osgDB::ListSerializer< C, P >::_getter

Referenced by ListSerializer(), and write().

## _name

template<typename C, typename P>

std::string osgDB::ListSerializer< C, P >::_name

Referenced by getName(), ListSerializer(), read(), and write().

## _setter

template<typename C, typename P>

Setter osgDB::ListSerializer< C, P >::_setter

Referenced by ListSerializer(), and read().

The documentation for this class was generated from the following file:

- Serializer